;/******************************/;
;/* Demo LED Latch For ET-EXP4 */;
;/* Files Name  : LAB1-EX1.ASM */;
;/* CPU Control : MCS51 Family */;
;/* Assembler   : SXA51.EXE    */;
;/*    (Output Latch LED-8)    */;
;/******************************/;
;
;/* Port For Control LED
PORT_LED    EQU     P1                  ; Port Drive LED

            ORG     0000H               ; Start Monitor
MAIN:       MOV     SP,#128-32          ; Stack = 32 Byte
            ;
LOOP1:      MOV     DPTR,#TAB_LED       ; Index Data Output LED
            MOV     R2,#8               ; 8-LED Display Counter
LOOP2:      CLR     A
            MOVC    A,@A+DPTR
            MOV     PORT_LED,A
            LCALL   DELAY
            INC     DPTR                ; Count-Up
            DJNZ    R2,LOOP2
            LJMP    LOOP1

;/**************/;
;/* Delay Time */;
;/**************/;
;
DELAY:      MOV     R3,#5
DLY1:       MOV     R4,#0FFH
DLY2:       MOV     R5,#0FFH
            DJNZ    R5,$
            DJNZ    R4,DLY2
            DJNZ    R3,DLY1
            RET

;/************************/;
;/* Table of LED Display */;
;/************************/;
;
TAB_LED:    DB      00000001B           ; LED-1 Display
            DB      00000010B           ; LED-2 Display
            DB      00000100B           ; LED-3 Display
            DB      00001000B           ; LED-4 Display
            DB      00010000B           ; LED-5 Display
            DB      00100000B           ; LED-6 Display
            DB      01000000B           ; LED-7 Display
            DB      10000000B           ; LED-8 Display

            END
            
