;/********************************/;
;/* Demo Display 5x7 For ET-EXP4 */;
;/* Files Name  : LAB3-EX1.ASM   */;
;/* CPU Control : MCS51 Family   */;
;/* Assembler   : SXA51.EXE      */;
;/*  (Scan Display Message 5*7)  */;
;/********************************/;
;
PORT_DSP    EQU     P1                  ; Port Display Control
;
;/** 74HC595 = Colum Control
COL_RESET   EQU     PORT_DSP.0          ; Reset  Clock  74HC595
COL_SHIFT   EQU     PORT_DSP.1          ; Shift  Clock  74HC595
COL_LATCH   EQU     PORT_DSP.2          ; Latch  Clock  74HC595
COL_ENABLE  EQU     PORT_DSP.3          ; Enable Output 74HC595
COL_DATA    EQU     PORT_DSP.5          ; Data   Input  74HC595
;
;/** 4017 = Row Control
ROW_ENABLE  EQU     PORT_DSP.4          ; Enable 4017
ROW_RESET   EQU     PORT_DSP.6          ; Reset 4017
ROW_DATA    EQU     PORT_DSP.7          ; Clock Input 4017

            ORG     20H
DSP_BUFF:   DS      14                  ; Display Buffer Font (14 Byte)
DATA_INX:   DS      1                   ; Index Read Buffer (SCAN_DSP)
INX_BUFF:   DS      3                   ; Display Code 3-Byte
STACK:      DS      32                  ; Stack 32 Byte

            ORG     0000H               ; Reset Vector
MAIN:       MOV     SP,#STACK           ; Stack = 32 Byte Internal RAM
            ;
            MOV     R2,#14
            MOV     R0,#DSP_BUFF        ; Clear Scan Buffer
            CLR     A
CLR_BUFF:   MOV     @R0,A
            INC     R0
            DJNZ    R2,CLR_BUFF
            ;
            MOV     INX_BUFF+0,#0       ; Code 0 = 5
            MOV     INX_BUFF+1,#1       ; Code 1 = *
            MOV     INX_BUFF+2,#2       ; Code 2 = 7
            LCALL   UNPK_DSP            ; Store Data to Memory Display
            ;
LOOP:       LCALL   SCAN_DSP            ; Get Memory Display to Display
            SJMP    LOOP

;/**********************************/;
;/* Get Code in INX_BUFF & Convert */;
;/* to Font and Store to DSP_BUFF  */;
;/* Input  : INX_BUFF0..2 (3-Code) */;
;/* Output : DSP_BUFF (Font Code)  */;
;/**********************************/;
;
UNPK_DSP:   MOV     DPTR,#TAB_FONT      ; Use Font 5x7
            MOV     A,INX_BUFF+0        ; 1st Code
            MOV     B,#7                ; 7-Byte : 1-Font
            MUL     AB                  ; AxB = Pointer Font
            CLR     C
            ADDC    A,DPL               ; Low Byte first
            MOV     DPL,A
            MOV     A,B
            ADDC    A,DPH               ; High Byte + Carry
            MOV     DPH,A
            ;
            MOV     R2,#7
            MOV     R0,#DSP_BUFF+0      ; Display Buffer Font-1
UNPK_DAT1:  CLR     A
            MOVC    A,@A+DPTR
            MOV     @R0,A
            INC     R0
            INC     DPTR
            DJNZ    R2,UNPK_DAT1
            ;
            MOV     DPTR,#TAB_FONT      ; Use Font 5x7
            MOV     A,INX_BUFF+1        ; 2nd Code
            MOV     B,#7                ; 7-Byte : 1-Font
            MUL     AB                  ; AxB = Pointer Font
            CLR     C
            ADDC    A,DPL               ; Low Byte first
            MOV     DPL,A
            MOV     A,B
            ADDC    A,DPH               ; High Byte + Carry
            MOV     DPH,A
            ;
            MOV     R2,#7
            MOV     R0,#DSP_BUFF+0      ; Display Buffer Font-1
UNPK_DAT2:  CLR     A
            MOVC    A,@A+DPTR
            RR      A                   ; Shift Right 5 Bit
            RR      A
            RR      A
            RR      A
            RR      A
            ANL     A,#00000111B
            ORL     A,@R0
            MOV     @R0,A
            INC     R0
            INC     DPTR
            DJNZ    R2,UNPK_DAT2
            ;
            MOV     DPTR,#TAB_FONT      ; Use Font 5x7
            MOV     A,INX_BUFF+1        ; 2nd Code
            MOV     B,#7                ; 7-Byte : 1-Font
            MUL     AB                  ; AxB = Pointer Font
            CLR     C
            ADDC    A,DPL               ; Low Byte first
            MOV     DPL,A
            MOV     A,B
            ADDC    A,DPH               ; High Byte + Carry
            MOV     DPH,A
            ;
            MOV     R2,#7
            MOV     R0,#DSP_BUFF+7      ; Display Buffer Font-2
UNPK_DAT3:  CLR     A
            MOVC    A,@A+DPTR
            RL      A                   ; Shift Left 3 Bit
            RL      A
            RL      A
            ANL     A,#11000000B
            MOV     @R0,A
            INC     R0
            INC     DPTR
            DJNZ    R2,UNPK_DAT3
            ;
            MOV     DPTR,#TAB_FONT      ; Use Font 5x7
            MOV     A,INX_BUFF+2        ; 3rd Code
            MOV     B,#7                ; 7-Byte : 1-Font
            MUL     AB                  ; AxB = Pointer Font
            CLR     C
            ADDC    A,DPL               ; Low Byte first
            MOV     DPL,A
            MOV     A,B
            ADDC    A,DPH               ; High Byte + Carry
            MOV     DPH,A
            ;
            MOV     R2,#7
            MOV     R0,#DSP_BUFF+7      ; Scan Buffer Font2
UNPK_DAT4:  CLR     A
            MOVC    A,@A+DPTR
            RR      A                   ; Shift Right 2 Bit
            RR      A
            ANL     A,#00111111B
            ORL     A,@R0
            MOV     @R0,A
            INC     R0
            INC     DPTR
            DJNZ    R2,UNPK_DAT4
            RET

;/********************************/;
;/* Get Data From Display Buffer */;
;/* and Scan Display 3 Dotmatrix */;
;/* Input : DSP_BUFF0..13(14Byte)*/;
;/********************************/;
;
SCAN_DSP:   SETB    COL_RESET           ; Start 74HC595 Pin
            CLR     ROW_ENABLE          ; Enable Row Output (4017)
            SETB    ROW_RESET           ; Clear Row Output Scan
            CLR     ROW_RESET
            ;
            MOV     R0,#DSP_BUFF+0      ; Display Buffer Left
            MOV     R1,#DSP_BUFF+7      ; Display Buffer Right
            MOV     B,#7                ; 7-Row Counter Scan
SCAN_DSP1:  SETB    COL_ENABLE          ; Disable Output Colum (74HC595)
            MOV     A,@R1               ; Right Digit
            CPL     A
            LCALL   SER_OUT             ; Send Data to Col 0-7
            MOV     A,@R0               ; Left Digit
            CPL     A
            LCALL   SER_OUT             ; Send Data to Col 8-15
            ;
            SETB    COL_LATCH           ; Latch Data Colum
            CLR     COL_LATCH
            SETB    ROW_DATA            ; Row Scan = Row Scan+1
            CLR     ROW_DATA
            CLR     COL_ENABLE          ; Enable Colum (74HCT595)
            ;
            MOV     R5,#1               ; Delay Time Counter
SCAN_DSP2:  MOV     R6,#00H
            DJNZ    R6,$
            DJNZ    R5,SCAN_DSP2        ; Delay for Eye
            INC     R0                  ; Next Row Buffer
            INC     R1
            DJNZ    B,SCAN_DSP1         ; Loop Until 7 Row Complete
            ;
            SETB    ROW_DATA            ; Shift Clock Over 1-Row
            CLR     ROW_DATA
            SETB    ROW_ENABLE          ; Disable Output Row (4017)
            RET

;/*************************/;
;/* Shift Data to 74HC595 */;
;/* Input : ACC           */;
;/*************************/;
;
SER_OUT:    MOV     R2,#8               ; Counter data ShiftOut 1 Byte
            CLR     CY
SHF_OUT:    RRC     A                   ; Shift Out data D0..D7
            MOV     COL_DATA,C
            NOP
            NOP
            SETB    COL_SHIFT           ; Shift Clock at Rising Edge
            NOP
            NOP
            CLR     COL_SHIFT
            NOP
            NOP
            DJNZ    R2,SHF_OUT          ; Loop Send This Byte
            RET

;/*********************/;
;/* Table of Font 5x7 */;
;/*********************/;
;
TAB_FONT:   DB      11111000B           ; 5
            DB      10000000B
            DB      11110000B
            DB      00001000B
            DB      00001000B
            DB      10001000B
            DB      01110000B
            ;
            DB      00000000B           ; *
            DB      00100000B
            DB      10101000B
            DB      01110000B
            DB      10101000B
            DB      00100000B
            DB      00000000B
            ;
            DB      11111000B           ; 7
            DB      00001000B
            DB      00010000B
            DB      00100000B
            DB      01000000B
            DB      01000000B
            DB      01000000B

            END
        
