;/*******************************/;
;/* Demo Step Motor For ET-EXP4 */;
;/* Files Name  : LAB5-EX1.ASM  */;
;/* CPU Control : MCS51 Family  */;
;/* Assembler   : SXA51.EXE     */;
;/*     (Wave Drive Control)    */;
;/*******************************/;
;
;/* Port For Control Stepping Motor
PORT_OUT    EQU     P1                  ; Step,Relay,Spk

            ORG     20H
STEP_CNT:   DS      1
CYCLECNT:   DS      1
STEP_INX:   DS      1
STACK:      DS      32

            ORG     0000H               ; Start Monitor
MAIN:       MOV     SP,#STACK           ; Stack = 32 Byte Internal RAM
            ;
WAVE_DRV:   MOV     CYCLECNT,#6
WAVE0:      MOV     STEP_CNT,#8         ; 8 Step/1 Cycle Counter
            MOV     STEP_INX,#0
WAVE1:      MOV     DPTR,#TAB_WAVE1     ; Wave Drive Table
            LCALL   OUT_STEP            ; Out Signal Drive
            INC     STEP_INX            ; Next Step
            DJNZ    STEP_CNT,WAVE1
            DJNZ    CYCLECNT,WAVE0
            LCALL   STEP_DLY
            ;
            MOV     CYCLECNT,#6
WAVE2:      MOV     STEP_CNT,#8         ; 8 Step/1 Cycle Counter
            MOV     STEP_INX,#0
WAVE3:      MOV     DPTR,#TAB_WAVE2     ; Wave Drive Table
            LCALL   OUT_STEP            ; Out Signal Drive
            INC     STEP_INX            ; Next Step
            DJNZ    STEP_CNT,WAVE3
            DJNZ    CYCLECNT,WAVE2
            LCALL   STEP_DLY
            ;
            LJMP    WAVE_DRV            ; Loop Continue

;/********************************/;
;/* Out Stepp Motor Signal Drive */;
;/* Input  : INX  = Table Signal */;
;/*        : Step Index          */;
;/* Output : Port  Signal        */;
;/********************************/;
;
OUT_STEP:   MOV     A,STEP_INX
            MOVC    A,@A+DPTR           ; Get Signal
            MOV     PORT_OUT,A
            ;
            MOV     R2,#200             ; Delay Step Rate
OUT_DLY1:   MOV     R3,#0FFH
            DJNZ    R3,$
            DJNZ    R2,OUT_DLY1
            RET

;/****************/;
;/*  Delay Time  */;
;/****************/;
;
STEP_DLY:   MOV     R2,#20
STEP_DL1:   MOV     R3,#0FFH
STEP_DL2:   MOV     R4,#0FFH
            DJNZ    R4,$
            DJNZ    R3,STEP_DL2
            DJNZ    R2,STEP_DL1
            RET

;/**********************/;
;/* Wave-Drive         */;
;/* Half Drive         */;
;/* ONE-Phase-ON Drive */;
;/* ONE-Excitation     */;
;/**********************/;
;
TAB_WAVE1:  DB      00000001B           ; Step-1 (Forward)
            DB      00000010B           ; Step-3
            DB      00000100B           ; Step-5
            DB      00001000B           ; Step-7
            DB      00000001B           ; Step-1
            DB      00000010B           ; Step-3
            DB      00000100B           ; Step-5
            DB      00001000B           ; Step-7
            ;
TAB_WAVE2:  DB      00001000B           ; Step-7 (Reverse)
            DB      00000100B           ; Step-5
            DB      00000010B           ; Step-3
            DB      00000001B           ; Step-1
            DB      00001000B           ; Step-7
            DB      00000100B           ; Step-5
            DB      00000010B           ; Step-3
            DB      00000001B           ; Step-1

            END

