;/******************************/;
;/* Demo LED Latch For ET-EXP4 */;
;/* Files Name  : LAB1-EX1.ASM */;
;/* CPU Control : 68HC811E2    */;
;/* Assembler   : AS11NEW.EXE  */;
;/*    (Output Latch LED-8)    */;
;/******************************/;
;
;/* Port For Control LED
PORT_LED    EQU     $1003               ; Data Drive LED (Port-C)
CTRL_LED    EQU     $1007               ; DDRC (0=In,1=Out)

            ORG     $F800               ; Start Monitor of 68HC811E2
MAIN        LDS     #$FF                ; Stack = Last Internal RAM
            LDAB    #$FF
            STAB    CTRL_LED            ; Port-C = Output
            ;
LOOP1       LDX     #TAB_LED            ; Index Data Output LED
            LDAB    #8                  ; 8-LED Display Counter
LOOP2       LDAA    0,X
            STAA    PORT_LED
            JSR     DELAY
            INX                         ; Count-Up
            DECB
            BNE     LOOP2
            BRA     LOOP1

;/**********************/;
;/* Delay Time 1Second */;
;/**********************/;
;
DELAY       PSHB                        ; Save Register
            PSHX
            LDAB    #100                ; 10mS x 100 = 1Second
DLY1        LDX     #$0D06              ; 10mS Count
DLY2        DEX
            BNE     DLY2
            DECB
            BNE     DLY1
            PULX                        ; Restore Register
            PULB
            RTS

;/************************/;
;/* Table of LED Display */;
;/************************/;
;
TAB_LED     FCB     %00000001           ; LED-1 Display
            FCB     %00000010           ; LED-2 Display
            FCB     %00000100           ; LED-3 Display
            FCB     %00001000           ; LED-4 Display
            FCB     %00010000           ; LED-5 Display
            FCB     %00100000           ; LED-6 Display
            FCB     %01000000           ; LED-7 Display
            FCB     %10000000           ; LED-8 Display

            ORG     $FFFE               ; Reset Vector
            FDB     MAIN

            END
            
