;/*******************************/;
;/* Demo Step Motor For ET-EXP4 */;
;/* Files Name  : LAB5-EX2.ASM  */;
;/* CPU Control : 68HC811E2     */;
;/* Assembler   : AS11NEW.EXE   */;
;/*     (Half Step Control)     */;
;/*******************************/;
;
;/* Port For Control Stepping Motor
PORT_OUT    EQU     $1004               ; Step,Relay,Spk (Port-B)

            ORG     $00
STEP_CNT    RMB     1
CYCLECNT    RMB     1
STEP_INX    RMB     1

            ORG     $F800               ; Start Monitor of 68HC811E2
MAIN        LDS     #$FF                ; Stack = Last Internal RAM
            ;
HALF_DRV    LDAA    #6
            STAA    CYCLECNT
HALF0       LDAA    #8
            STAA    STEP_CNT            ; 8 Step/1 Cycle Counter
            LDAA    #0
            STAA    STEP_INX
HALF1       LDX     #TAB_HALF1          ; Half Step Drive Table
            JSR     OUT_STEP            ; Out Signal Drive
            INC     STEP_INX            ; Next Step
            DEC     STEP_CNT
            BNE     HALF1
            DEC     CYCLECNT
            BNE     HALF0
            JSR     STEP_DLY
            ;
            LDAA    #6
            STAA    CYCLECNT
HALF2       LDAA    #8
            STAA    STEP_CNT            ; 8 Step/1 Cycle Counter
            LDAA    #0
            STAA    STEP_INX
HALF3       LDX     #TAB_HALF2          ; Half Step Drive Table
            JSR     OUT_STEP            ; Out Signal Drive
            INC     STEP_INX            ; Next Step
            DEC     STEP_CNT
            BNE     HALF3
            DEC     CYCLECNT
            BNE     HALF2
            JSR     STEP_DLY
            BRA     HALF_DRV            ; Loop Continue

;/********************************/;
;/* Out Stepp Motor Signal Drive */;
;/* Input  : INX  = Table Signal */;
;/*        : Step Index          */;
;/* Output : PortC Signal        */;
;/********************************/;
;
OUT_STEP    LDAB    STEP_INX
            ABX
            LDAA    0,X                 ; Get Signal
            STAA    PORT_OUT            ; Port-B
            ;
            LDAB    #10                 ; 10x10 = 100mS Count
OUT_DLY1    LDX     #$0D06              ; 10 mSec Counter
OUT_DLY2    DEX
            BNE     OUT_DLY2
            DECB
            BNE     OUT_DLY1
            RTS

;/************************/;
;/*  Delay Time 1 Second */;
;/************************/;
;
STEP_DLY    PSHB
            PSHX
            LDAB    #100                ; 100x10 = 1000mS Count
STEP_DL1    LDX     #$0D06              ; 10 mSec Counter
STEP_DL2    DEX
            BNE     STEP_DL2
            DECB
            BNE     STEP_DL1
            PULX
            PULB
            RTS

;/**********************/;
;/* Half Step Drive    */;
;/* ONE-TWO-Excitation */;
;/**********************/;
;
TAB_HALF1   FCB     %00000001           ; Step-1 (Forward)
            FCB     %00000011           ; Step-2
            FCB     %00000010           ; Step-3
            FCB     %00000110           ; Step-4
            FCB     %00000100           ; Step-5
            FCB     %00001100           ; Step-6
            FCB     %00001000           ; Step-7
            FCB     %00001001           ; Step-8
            ;
TAB_HALF2   FCB     %00001001           ; Step-8 (Reverse)
            FCB     %00001000           ; Step-7
            FCB     %00001100           ; Step-6
            FCB     %00000100           ; Step-5
            FCB     %00000110           ; Step-4
            FCB     %00000010           ; Step-3
            FCB     %00000011           ; Step-2
            FCB     %00000001           ; Step-1
            
            ORG     $FFFE               ; Reset Vector
            FDB     MAIN

            END

